var/list/minimap=new
var/maprendering=0
world
	New()
		..()
		TPixelGet1(1)

image
	Highlight
		icon='objs.dmi'
		icon_state="highlight"
		color=list("purple","purple","purple")
var/list/highlights[world.maxz]
proc
	HighlightMap(var/turf/t)//Add marker to a list to be added by ChangeIcon()
		if(!highlights[t.z])
			highlights[t.z]=new/list
		var/px=round(t.x*4,1)-16
		var/py=round(t.y*4,1)-16
		var/image/Highlight/hl=new
		hl.transform*=0.125
		hl.pixel_x=px
		hl.pixel_y=py
		highlights[t.z]+=hl
	TPixelGet1(bypass=0)//Call at world New(), This a minimap of all maps
		set waitfor=FALSE
		set background=1
		if(!LoadMiniMap()||bypass)//Checks if theres a previous minimap icon that can be loaded
			/*
			for(var/p in typesof(/turf))//This loop creates the miniture version of all turfs in game so can be used for
				var/turf/t=new p(locate(1,1,1),"MiniMap")
				var/icon/i=icon(t.icon,t.icon_state)
				if(t.icon==null||!i.GetPixel(i.Width()/2,i.Height()/2)||i==null)
					continue
				var/scalex=i.Width()/8
				var/scaley=i.Height()/8
				if(scalex<1) scalex=(1-scalex)*15
				if(scaley<1) scaley=(1-scaley)*15
				i.Scale(scalex,scaley)
				minimap[t.type]=i
			for(var/p in typesof(/obj))//This loop creates the miniture version of all objs in game so can be used for
				if(p in list(/obj,/obj))
				else//Skip certain items
					var/obj/t=new p
					if(t==null) continue
					var/icon/i=icon(t.icon,t.icon_state)
					var/scalex=i.Width()/8
					var/scaley=i.Height()/8
					if(scalex<1) scalex=(1-scalex)*15
					if(scaley<1) scaley=(1-scaley)*15
					i.Scale(scalex,scaley)
					minimap[t.type]=i*/
			world<<"Rendering World Map"
			var/icon/lastimage
			world<<"Turfs..."
			for(var/turf/T in world)//This loop puts all the minimap turfs together
				if(maprendering!=T.z)
					maprendering=T.z
					world<<"Turf Map [maprendering]"
				if(T.type==/turf) continue
				var/icon/worldicon=wholemap[T.z]
				if(!wholemap[T.z])
					wholemap[T.z]=new/icon('blank2.dmi')
					var/sizex=world.maxx
					var/sizey=world.maxy
					worldicon=wholemap[T.z]
					worldicon.Crop(sizex*4,sizey*4)
				if(!minimap[T.type])
					var/icon/i=icon(T.icon,T.icon_state)
					//if(T.icon==null||!i.GetPixel(i.Width()/2,i.Height()/2)||i==null) continue
					var/scalex=i.Width()/8
					var/scaley=i.Height()/8
					if(scalex<1) scalex=(1-scalex)*15
					if(scaley<1) scaley=(1-scaley)*15
					i.Scale(scalex,scaley)
					minimap[T.type]=i
				var/imageobj=minimap[T.type]
				if(!isicon(imageobj))//If no icon for turf we will just use the last icon found
					imageobj=lastimage
				//else lastimage=imageobj
				if(imageobj) worldicon.Blend(imageobj,ICON_OVERLAY,T.x*4,T.y*4)
				sleep(1*world.tick_lag-1)
				//if(T.x==world.maxx&&T.y%2==0)//Incrementally sleep so game doesn't completely pause while rendering
					//sleep(1)
			world<<"objs..."
			maprendering=0
			for(var/obj/T in world)//Same as turfs but for objects
				if(maprendering!=T.z)
					maprendering=T.z
					world<<"Objs Map [maprendering]"
				if(T.z==0) continue
				var/icon/worldicon=wholemap[T.z]
				if(!minimap[T.type])
					var/icon/i=icon(T.icon,T.icon_state)
					//if(T.icon==null||!i.GetPixel(i.Width()/2,i.Height()/2)||i==null) continue
					var/scalex=i.Width()/8
					var/scaley=i.Height()/8
					if(scalex<1) scalex=(1-scalex)*15
					if(scaley<1) scaley=(1-scaley)*15
					i.Scale(scalex,scaley)
					minimap[T.type]=i
				var/imageobj=minimap[T.type]
				if(!isicon(imageobj))
					imageobj=lastimage
					sleep(1)
				//else lastimage=imageobj
				if(imageobj)
					if(T.color)
						if(T.color=="#0000ff")
							worldicon.Blend(imageobj+rgb(0,0,255),ICON_OVERLAY,T.x*4,T.y*4)
						else
							worldicon.Blend(imageobj+rgb(255,0,0),ICON_OVERLAY,T.x*4,T.y*4)
					else worldicon.Blend(imageobj,ICON_OVERLAY,T.x*4,T.y*4)
				sleep(1*world.tick_lag-1)
				//if(T.x%(world.maxx)==0)
					//sleep(rand(0,1))
			world<<"Saving World MiniMap"
			SaveMiniMap()
var/list/wholemap[world.maxz]
mob
	var
		obj
			tmp
				worldmap//Each player need a copy of the world map since each image will be shifting depend on the players location
				planemaster//defined to display allys/enemy objects on it
		image/border/miniborder
		image/visiblearea/minivisible
	proc
		GiveMiniHud()//Gives basic minimap hud elements
			worldmap=new/obj/WorldMap
			planemaster=new/obj/minimap_plane
			minivisible=new
			miniborder=new
			client.screen += planemaster
			planemaster.overlays += minivisible
			planemaster.overlays += miniborder
			client.screen += worldmap
			FigureUpdate("[minianchory]:[minipy],[minianchorx]:[minipx]")
obj
	Indicator
		icon='objs.dmi'
		icon_state="indicator"
	WorldMap
		appearance_flags=TILE_BOUND
		blend_mode = BLEND_MULTIPLY
		plane = 2
		layer=4
		Click(loc,ctrl,params)//This creates the locations indicator and has user walk to clicked area
			var/list/p=params2list(params)
			var/px=text2num(p["icon-x"])
			var/py=text2num(p["icon-y"])
			var/turf/t=locate(round(px/4,1),round(py/4,1),1)
			walk_to(usr,t)
			var/image/i=new
			i.layer=19
			i.pixel_x=px-16
			i.pixel_y=py-16
			i.plane=3
			i.icon=icon('objs.dmi',"indicator")
			i.transform*=0.125
			src.OverPut(/obj/Indicator,10)
			t.OverPut(/obj/Indicator,10)
		proc
			ChangeIcon(mob/O)//Function called when player moves to make minimap move

				set waitfor=FALSE
				if(O&&wholemap.len>=O.z&&O.z)
					src.overlays-=highlights[O.z]
					src.overlays+=highlights[O.z]
					src.icon=wholemap[O.z]
					var/icon/worldicon=wholemap[1]
					if(worldicon)
						var/px=minipx-round(miniwidth/2,1)-(O.x-32)*4-12
						var/py=minipy-round(miniheight/2,1)-(O.y-32)*4-12
						//world<<"[minianchory]:[py],[minianchorx]:[px]"
						screen_loc = "[minianchory]:[py],[minianchorx]:[px]"
						//world<<src
var/minianchorx="EAST"
var/minianchory="SOUTH"
var/minipx=0
var/minipy=0
var/miniheight=0
var/miniwidth=0
obj/minimap_plane//Master Plane
	plane = 2
	blend_mode = BLEND_DEFAULT
	appearance_flags = PLANE_MASTER | NO_CLIENT_COLOR | TILE_BOUND
	//mouse_opacity = 0
	New()
		..()
		var/icon/i=new('blank2.dmi',"white")
		miniheight=i.Height()-32
		miniwidth=i.Width()-32
		if(minianchory=="NORTH")
			minipy=-miniheight
		if(minianchorx=="EAST")
			minipx=-miniwidth
		screen_loc = "[minianchory]:[minipy],[minianchorx]:[minipx]"
image/visiblearea
	plane = 2
	blend_mode = BLEND_ADD
	icon = 'blank2.dmi'//White icon crops minimap(Visible Area of minimap)
	icon_state="whitesquare"
image/border
	plane = 2
	blend_mode = BLEND_ADD
	icon = 'blank2.dmi'  //Gives minimap a circular black border
	icon_state="blacksquare"
	color=rgb(0,102,102)
proc//Saving and loading so you dont have to recreate the entire world maps each reboot
	SaveMiniMap()
		var/savefile/F=new("savefiles/minimap.sav")
		F<<wholemap
	LoadMiniMap()
		var/savefile/F=new("savefiles/minimap.sav")
		var/list/l
		F>>l
		if(l)
			world<<"World MiniMap Loaded"
			wholemap=l
			return 1
		return 0
atom
	proc
		OverPut(obj/M,time=null)
			set waitfor = FALSE
			src.overlays+=M
			if(time)
				sleep(time)
				src.overlays-=M
mob
	proc
		FigureUpdate(screenloc)//Function that shows nearby allies, enemies and self on minimap
			set waitfor=FALSE
			if(!src.client) return
			var/obj/j=planemaster
			var/list/objects=new
			j.screen_loc=screenloc
			src.client.screen+=j
			while(src)
				for(var/mob/T in viewers(16))
					if(T)//.dead==0)
						var/image/i
						if(objects[T])
							i=objects[T]
							i.pixel_x=0
							i.pixel_y=0
						else
							i=new
							if(T==src)
								i=image(/obj/Spot/You,,,3)
							else i=image(/obj/Spot/Enemy,,,2)
								/*
								if(src.team.type==T.team) i=image(/obj/Spot/Enemy,,,2)
								else i=image(/obj/Spot/Ally,,,2)*/
							objects[T]=i
						i.pixel_x=miniwidth/2+(T.x-src.x)*4
						i.pixel_y=miniheight/2+(T.y-src.y)*4
						j.OverPut(i,2)
				sleep(2)
obj
	Spot
		plane=3
		icon='Piece.dmi'
		Cover
			icon_state="cover"
			layer=MOB_LAYER+16
			screen_loc="19,19 to 21,21"
		Ally
			icon_state="ally"
		Question
			icon_state="?"
		Question2
			icon_state="?2"
		Exclamation
			icon_state="!"
		Enemy
			icon_state="enemy"
		Creature
			icon_state="creature"
		You
			icon_state="you"
		Boss
			icon_state="boss"
